Index: uspace/drv/char/msim-con/msim-con.c
===================================================================
--- uspace/drv/char/msim-con/msim-con.c	(revision 59953b57828b7195c42a7c30df3c06369f96e51b)
+++ uspace/drv/char/msim-con/msim-con.c	(revision c309b18982aa8ed31fd796bcd813732f5f312e6e)
@@ -106,4 +106,10 @@
 	}
 
+	rc = pio_enable((void *)res->base, 1, (void **) &con->out_reg);
+	if (rc != EOK) {
+		ddf_msg(LVL_ERROR, "Error enabling I/O");
+		goto error;
+	}
+
 	ddf_fun_set_conn_handler(fun, msim_con_connection);
 
@@ -131,4 +137,6 @@
 		goto error;
 	}
+
+	ddf_fun_add_to_category(fun, "console");
 
 	return EOK;
@@ -157,4 +165,5 @@
 static void msim_con_putchar(msim_con_t *con, uint8_t ch)
 {
+	pio_write_8(con->out_reg, ch);
 }
 
Index: uspace/drv/char/msim-con/msim-con.h
===================================================================
--- uspace/drv/char/msim-con/msim-con.h	(revision 59953b57828b7195c42a7c30df3c06369f96e51b)
+++ uspace/drv/char/msim-con/msim-con.h	(revision c309b18982aa8ed31fd796bcd813732f5f312e6e)
@@ -39,4 +39,5 @@
 #include <async.h>
 #include <ddf/driver.h>
+#include <ddi.h>
 #include <fibril_synch.h>
 #include <io/chardev_srv.h>
@@ -66,4 +67,5 @@
 	fibril_mutex_t buf_lock;
 	fibril_condvar_t buf_cv;
+	ioport8_t *out_reg;
 } msim_con_t;
 
Index: uspace/srv/hid/output/Makefile
===================================================================
--- uspace/srv/hid/output/Makefile	(revision 59953b57828b7195c42a7c30df3c06369f96e51b)
+++ uspace/srv/hid/output/Makefile	(revision c309b18982aa8ed31fd796bcd813732f5f312e6e)
@@ -35,5 +35,4 @@
 	ctl/serial.c \
 	port/ega.c \
-	port/kchar.c \
 	port/chardev.c \
 	proto/vt100.c \
Index: uspace/srv/hid/output/output.c
===================================================================
--- uspace/srv/hid/output/output.c	(revision 59953b57828b7195c42a7c30df3c06369f96e51b)
+++ uspace/srv/hid/output/output.c	(revision c309b18982aa8ed31fd796bcd813732f5f312e6e)
@@ -36,5 +36,4 @@
 #include <config.h>
 #include "port/ega.h"
-#include "port/kchar.h"
 #include "port/chardev.h"
 #include "output.h"
@@ -477,5 +476,4 @@
 	if (!config_key_exists("console")) {
 		ega_init();
-		kchar_init();
 	}
 	
Index: uspace/srv/hid/output/port/chardev.c
===================================================================
--- uspace/srv/hid/output/port/chardev.c	(revision 59953b57828b7195c42a7c30df3c06369f96e51b)
+++ uspace/srv/hid/output/port/chardev.c	(revision c309b18982aa8ed31fd796bcd813732f5f312e6e)
@@ -190,4 +190,6 @@
 #elif defined(UARCH_sparc64) && defined(PROCESSOR_sun4v)
 		/* OK */
+#elif defined(MACHINE_msim)
+		/* OK */
 #else
 		return EOK;
Index: pace/srv/hid/output/port/kchar.c
===================================================================
--- uspace/srv/hid/output/port/kchar.c	(revision 59953b57828b7195c42a7c30df3c06369f96e51b)
+++ 	(revision )
@@ -1,98 +1,0 @@
-/*
- * Copyright (c) 2006 Ondrej Palkovsky
- * Copyright (c) 2008 Martin Decky
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-/** @file
- */
-
-#include <stdint.h>
-#include <errno.h>
-#include <str.h>
-#include <sysinfo.h>
-#include <ddi.h>
-#include <align.h>
-#include <as.h>
-#include "../ctl/serial.h"
-#include "kchar.h"
-
-typedef struct {
-	uint8_t *addr;
-} kchar_t;
-
-static kchar_t kchar;
-
-static void kchar_putchar(wchar_t ch)
-{
-	if (ascii_check(ch))
-		*kchar.addr = ch;
-	else
-		*kchar.addr = '?';
-}
-
-static void kchar_control_puts(const char *str)
-{
-	while (*str)
-		*kchar.addr = *(str++);
-}
-
-int kchar_init(void)
-{
-	sysarg_t present;
-	int rc = sysinfo_get_value("fb", &present);
-	if (rc != EOK)
-		present = false;
-	
-	if (!present)
-		return ENOENT;
-	
-	sysarg_t kind;
-	rc = sysinfo_get_value("fb.kind", &kind);
-	if (rc != EOK)
-		kind = (sysarg_t) -1;
-	
-	if (kind != 3)
-		return EINVAL;
-	
-	sysarg_t paddr;
-	rc = sysinfo_get_value("fb.address.physical", &paddr);
-	if (rc != EOK)
-		return rc;
-	
-	kchar.addr = AS_AREA_ANY;
-	
-	rc = physmem_map(paddr,
-	    ALIGN_UP(1, PAGE_SIZE) >> PAGE_WIDTH,
-	    AS_AREA_READ | AS_AREA_WRITE, (void *) &kchar.addr);
-	if (rc != EOK)
-		return rc;
-	
-	return serial_init(kchar_putchar, kchar_control_puts);
-}
-
-/** @}
- */
Index: pace/srv/hid/output/port/kchar.h
===================================================================
--- uspace/srv/hid/output/port/kchar.h	(revision 59953b57828b7195c42a7c30df3c06369f96e51b)
+++ 	(revision )
@@ -1,41 +1,0 @@
-/*
- * Copyright (c) 2006 Ondrej Palkovsky
- * Copyright (c) 2008 Martin Decky
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-/** @file
- */
-
-#ifndef OUTPUT_PORT_KCHAR_H_
-#define OUTPUT_PORT_KCHAR_H_
-
-extern int kchar_init(void);
-
-#endif
-
-/** @}
- */
